// PrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Pr.h"
#include "PrDlg.h"
#include "WinAdr.h"
#include "h.h"
#include "Maco.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrDlg dialog

CPrDlg::CPrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPrDlg)
	m_soob = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrDlg)
	DDX_Text(pDX, IDC_EDITsoob, m_soob);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPrDlg, CDialog)
	//{{AFX_MSG_MAP(CPrDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_MENUreadPLIS, OnMENUreadPLIS)
	ON_COMMAND(ID_openCOM, OnopenCOM)
	ON_COMMAND(ID_MENUexit, OnMENUexit)
	ON_COMMAND(ID_MENUaco, OnMENUaco)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrDlg message handlers

BOOL CPrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPrDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPrDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPrDlg::OnMENUreadPLIS() 
{
  
 int adr;
 byte al,ah;
 char soob[50];
 int i;
 
 m_soob.Empty();
 m_soob.Format("              RD_PLIS:    " );
	
	
 WinAdr winAdrPlis; //  .  
 winAdrPlis.flRW=false;
 winAdrPlis.DoModal(); //  
 adr = winAdrPlis.iAdressPlis;
	
 al=adr&0xff;
 ah=(adr&0xff00)>>8;

 RDPLIS(al,ah);

	sprintf(soob,"\r\n buf_otv\r\n");
	m_soob += soob;
	for(i=0;i<=17;i++)
    {
		sprintf(soob,"  %2x",buf_otv[i]);
		m_soob += soob;
    }
	UpdateData(false);
	
}

byte CPrDlg::RDPLIS(byte al, byte ah)
{
byte buf_kom[18]={0xa0,0x18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
 //,  ., ..., ...(.  -3)
 int rec_state,kp;
 byte kod;

	kod=0x30;				//  
	kp=1;
	buf_kom[2]=al;
	buf_kom[3]=ah;
pp:	this->SEND_RS(buf_kom);
	kp++;
// 
	rec_state=this->REC_RS(kod);
	if(rec_state==1||rec_state==3){
		MessageBox("  REC_ERR");
		return 1;
		}
	if(rec_state==2){
		if(kp<=3)goto pp;
		MessageBox("  REC_ERR");
		return 1;
		}
	return buf_otv[4];
}

int CPrDlg::SEND_RS(byte buf_kom[])
{
int i,n;

 n = kol_vo(buf_kom[0]) + 1;
 for(i=0;i<n;i++)buf_kom[n] += buf_kom[i];
 
 outbyte(0,0x80); // 
 
 for(i=0;i<(n+1);i++)outbyte(0,buf_kom[i]);	
return 0;
}

void CPrDlg::outbyte(int nPort, byte bb)
{
boolean kz = true;
while (kz)
{
 kz= ((Inp32(comm[nPort].aPort+5) & 0x20)==0);
}
Out32(comm[nPort].aPort,bb);
}

//     

int CPrDlg::InitOpenPort(int nPort, int dBaudRate)
{
	comm[0].sName="COM1";
	comm[0].aPort=0x3f8;
	comm[1].sName="COM2";
	comm[1].aPort=0x2f8;
    hCOM=CreateFile(comm[nPort].sName, //  
                  GENERIC_WRITE|GENERIC_READ, //.   
                  0,//   0,.   
                  NULL,//  
	              OPEN_EXISTING,//  
			      FILE_ATTRIBUTE_NORMAL,//
			      NULL);//   

	if (hCOM==INVALID_HANDLE_VALUE)
	{
		CloseHandle(hCOM);
		MessageBox("   !");
		return 1;
	}
	else
	{
		Out32((comm[nPort].aPort+3), 0x80);
		Out32(comm[nPort].aPort+1, 0);
		Out32(comm[nPort].aPort  , 3);

		Out32(comm[nPort].aPort+3, 0x3f);
		Out32(comm[nPort].aPort+1, 0);
		return 0;
	}
}

void CPrDlg::OnopenCOM() 
{
 // ,   
 if (InitOpenPort(0, 38400) != 0)
 {
	MessageBox(" :   !");
	OnOK();
 }	
}

int CPrDlg::REC_RS(byte kod)
{
int i,n;
byte bDan;
byte ksum=0;

for(i=0;i<sizeof(buf_otv);i++)buf_otv[i]=0;
bDan=inbyte(0);
if ((rec_state==0) & (bDan == 0x80))
{
  bDan=inbyte(0);
  if((bDan&0xfe)== kod)
  {
     buf_otv[0]=bDan;
	 n = kol_vo(bDan);
	 ksum = buf_otv[0];
     for(i=1;i<=n;i++)
	 {
		 buf_otv[i] = inbyte(0);
		 if (rec_state != 0) return rec_state;
		 else (ksum += buf_otv[i]);
	 } 
	 buf_otv[i]=inbyte(0);
	 if (ksum!=buf_otv[i]) rec_state = 2;
	 else rec_state=0;
  }
  else (rec_state = 3);
  }
else
{ 
   if (bDan!=0x80) rec_state = 1;
}
return rec_state;
}

byte CPrDlg::inbyte(int nPort)
{
int i;
int n=25000;
for(i=0;i<n;i++)
{
	if(Inp32(comm[nPort].aPort+5) & 1)break;
}

if (i<n)
{
	rec_state = 0;
	return ((byte) Inp32(comm[nPort].aPort));
} 
else 
{ 
	rec_state =1 ;
	return 0xff;
}
}

int CPrDlg::kol_vo(byte bb)
{
 int i; 
 	xlgtab[0]=1;
	xlgtab[1]=2;
	xlgtab[2]=3;
	xlgtab[3]=4;
	xlgtab[4]=5;
	xlgtab[5]=8;
	xlgtab[6]=12;
	xlgtab[7]=16;
 i = ((bb&0x70)>>4);
 return xlgtab[i];
}

void CPrDlg::OnMENUexit() 
{
  		    CloseHandle(hCOM);
			OnOK();
	
}

void CPrDlg::OnMENUaco() 
{
  Maco WinACO;
  WinACO.DoModal();
}
